const tailwindcss = require('tailwindcss')
const autoprefixer = require('autoprefixer')
const postcssImport = require('postcss-import')
const postcssnested = require('postcss-nested')
const purgecss = require('@fullhuman/postcss-purgecss')

class TailwindExtractor {
  static extract(content) {
    return content.match(/[A-Za-z0-9-_:/]+/g) || []
  }
}

const plugins = [tailwindcss('./tailwind.js'), autoprefixer, postcssImport, postcssnested]

if (process.env.NODE_ENV === 'production') {
  plugins.push(
    purgecss({
      content: ['./src/App.vue', './src/components/**/*.vue', './src/views/**/*.vue'],
      whitelist: ['html', 'body'],
      extractors: [
        {
          extractor: TailwindExtractor,
          extensions: ['html', 'vue'],
        },
      ],
    })
  )
}

module.exports = { plugins }
